package sampleSearchDissociation;

import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;


/**
 * Text evaluates a DNF formula with with Vibhav's tool 'SampleSearch'.
 * @author Wolfgang Gatterbauer
 * @version First Version: July 26, 2010
 * @version This Version: Oct 22, 2013
 */
public class Test_DNFevaluationSampleSearch {

	public static void main(String[] args) {

		/* --- Define DNF for P4 --- */
		HashSet<Clause> clauseSet = new HashSet<Clause>();	
		clauseSet.add(new Clause(new LinkedList<Integer>(Arrays.asList(11, 21, 31))));
		clauseSet.add(new Clause(new LinkedList<Integer>(Arrays.asList(11, 22, 32))));
		clauseSet.add(new Clause(new LinkedList<Integer>(Arrays.asList(12, 23, 32))));
		DNF exampleDNF = new DNF(clauseSet);

		double r1 = 0.1;
		double r2 = 0.91;
		double s1 = 0.35;
		double s2 = 0.1;
		double s3 = 0.9;
		double t1 = 0.212;
		double t2 = 0.3;

		double pGT = r1 * (t2 * (1- (1-s2)*(1-s1*t1)*(1-r2*s3)) 
				+ (1-t2)*s1*t1)
				+(1-r1)*r2*s3*t2;			// calculate GT

		HashMap<Integer,Double> probMap = new HashMap<Integer,Double>();
		probMap.put(11, r1);
		probMap.put(12, r2);
		probMap.put(21, s1);
		probMap.put(22, s2);
		probMap.put(23, s3);
		probMap.put(31, t1);
		probMap.put(32, t2);
		DNF.setProb(probMap);			// note the static assignment for probabilities


		/* --- Print DNF --- */
		System.out.println("Evalute P(Phi) with Vibhav tool 'SampleSearch'\n");
		System.out.println("DNF: \n" + exampleDNF + "\n");

		
		/* --- Evaluate DNF --- */
		DNFevaluationSampleSearch.writeInputFile(exampleDNF);
		long time = DNFevaluationSampleSearch.executeProgram();
		double p = DNFevaluationSampleSearch.readOutput();
		System.out.println("P(Phi) = " + p + "    in time: " + time);
		System.out.println("P GT   = " +pGT + "\n");

	}

}
